# CSPR supply

The `Supply` entity holds information about total and circulating supply of the Mainnet CSPR token. The circulating supply is calculated according to the [approach described on the Casper website](https://casper.network/en-us/news/update-on-circulating-supply/).

{% hint style="info" %}
At this moment, the API returns correct circulating supply only on the Mainnet
{% endhint %}

## Properties

The `Supply` entity has the following properties:

| Property                            | Type         | Description                                                                                                                                                             |
| ----------------------------------- | ------------ | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `token`                             | `string(64)` | Token represented by the supply data. At this point, the value is always `CSPR`                                                                                         |
| `total`                             | `uint64`     | Total available supply of the token                                                                                                                                     |
| `circulating`                       | `uint64`     | Circulating supply of the token calculated according to the [approach described on the Casper website](https://casper.network/en-us/news/update-on-circulating-supply/) |
| `total_annual_issuance`             | `float64`    | Total annual issuance rate                                                                                                                                              |
| `annual_ecosystem_sustain_issuance` | `float64`    | Ecosystem sustain issuance component                                                                                                                                    |
| `annual_staking_rewards_issuance`   | `float64`    | Staking rewards issuance component, calculated as `total_annual_issuance - annual_ecosystem_sustain_issuance`                                                           |
| `annual_issuance`                   | `float64`    | Deprecated. Use `total_annual_issuance`                                                                                                                                 |
| `timestamp`                         | `datetime`   | The latest timestamp when the supply value was updated                                                                                                                  |

**Example**

```json
{
  "data": {
    "token": "CSPR",
    "total": 13549811451,
    "circulating": 13087471947,
    "total_annual_issuance": 0.0821,
    "annual_ecosystem_sustain_issuance": 0.020525,
    "annual_staking_rewards_issuance": 0.061575,
    "annual_issuance": 0.0821,
    "timestamp": 1747731497
  }
}
```

## Optional properties

None

## Relations

None

## Endpoints

The `Supply` entity has the following endpoints:

* [Get supply](/rest-api/cspr-supply/get-supply.md)

## Relation endpoints

None


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/rest-api/cspr-supply.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
